/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.stresstestingreporttemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumContinuityOfContent;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.echocardiographyprocedurereport.EchoMeasurement_TID5203;
import cdac.medinfo.sdk.dcm30_04.templates.echocardiographyprocedurereport.WallMotionAnalysis_TID5204;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressEchoMeasurementGroup;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StressEchoMeasurementGroup;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents StressEchoMeasurementGroup_TID3309
 */
public class StressEchoMeasurementGroup_TID3309 extends Template
{
	
	/**
	 * Object of WallMotionAnalysis_TID5204
	 */
	private WallMotionAnalysis_TID5204 objWallMotionAnalysisTID5204;
	
	/**
	 * Object of EchoMeasurement_TID5203
	 */
	private EchoMeasurement_TID5203 objEchoMeasurementTID5203;
	
	/**
	 * Instantiates a new StressEchoMeasurementGroup_TID3309 Template.
	 * @param objTree Object of SRTree.
	 */
	public StressEchoMeasurementGroup_TID3309(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Retrieves Echo Measurement.
	 * @return objEchoMeasurementTID5203 Object of EchoMeasurement_TID5203 
	 */
	public EchoMeasurement_TID5203 getEchoMeasurement()
	{
		if(null == this.objEchoMeasurementTID5203)
			this.objEchoMeasurementTID5203 = new EchoMeasurement_TID5203(getSRTree());
		return this.objEchoMeasurementTID5203;
	}
	
	/**
	 * Retrieves Wall Motion Analysis.
	 * @return objWallMotionAnalysisTID5204 Object of WallMotionAnalysis_TID5204 
	 */
	public WallMotionAnalysis_TID5204 getWallMotionAnalysis()
	{
		if(null == this.objWallMotionAnalysisTID5204)
			this.objWallMotionAnalysisTID5204 = new WallMotionAnalysis_TID5204(getSRTree());
		return this.objWallMotionAnalysisTID5204;
	}
	
	/**
	 * Sets the value for Procedure reported.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setProcedureReported(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.PROCEDURE_REPORTED.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.PROCEDURE_REPORTED_121058.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, "", "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Echocardiography.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setEchocardiography(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.ECHOCARDIOGRAPHY.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.ECHOCARDIOGRAPHY_P5_B3000.getValue();
		String strCSD = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, "", "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
		
	/**
	 * Sets the value for Finding Site.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setFindingSite(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.FINDING_SITE.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.FINDING_SITE_G_C0E3.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue,"", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}

	
	/**
	 * Sets the value for Left Ventricle.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setLeftVentricle(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.LEFT_VENTRICLE.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.LEFT_VENTRICLE_T_32600.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Aortic Valve.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setAorticValve(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.AORTIC_VALVE.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.AORTIC_VALVE_T_35400.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	
	/**
	 * Sets the value for Mitral Valve.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void setMitralValve(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.MITRAL_VALVE.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.MITRAL_VALVE_T_35300.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for Findings.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumContinuityOfContent 
	 */
	public void setFindings(int[] arrPosition, EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.FINDINGS.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.FINDINGS_121070.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
	
		/**
		 * Creating a node of Value Type CONTAINER and adding this node as root of a tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createContainer(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, enumContinuityOfContent);
		getSRTree().addChild(objContentSequenceItem);

	}
	
	/**
	 * Sets the value for Tricuspid Valve.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 */
	public void seTricuspidValve(int[] arrPosition)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_StressEchoMeasurementGroup.TRICUSPID_VALVE.getValue();
		String strCodeValue = EnumCV_StressEchoMeasurementGroup.TRICUSPID_VALVE_T_35100.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 *Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, "", strCSDesg, "", "","");
		getSRTree().addChild(objContentSequenceItem);
		
	}

}
